# Yahoo! UI Library

### paginator 2.6.0

Yahoo! UI Library > paginator > FirstPageLink.js (source view)

Show Private Show Protected Show Deprecated

    (function () {

    var Paginator = YAHOO.widget.Paginator,
        l         = YAHOO.lang;

    /**
     * ui Component to generate the link to jump to the first page.
     *
     * @namespace YAHOO.widget.Paginator.ui
     * @class FirstPageLink
     * @for YAHOO.widget.Paginator
     *
     * @constructor
     * @param p {Pagintor} Paginator instance to attach to
     */
    Paginator.ui.FirstPageLink = function (p) {
        this.paginator = p;

        p.createEvent('firstPageLinkLabelChange');
        p.createEvent('firstPageLinkClassChange');

        p.subscribe('recordOffsetChange',this.update,this,true);
        p.subscribe('rowsPerPageChange',this.update,this,true);
        p.subscribe('totalRecordsChange',this.update,this,true);
        p.subscribe('destroy',this.destroy,this,true);

        // TODO: make this work
        p.subscribe('firstPageLinkLabelChange',this.update,this,true);
        p.subscribe('firstPageLinkClassChange',this.update,this,true);
    };

    /**
     * Decorates Paginator instances with new attributes. Called during
     * Paginator instantiation.
     * @method init
     * @param p {Paginator} Paginator instance to decorate
     * @static
     */
    Paginator.ui.FirstPageLink.init = function (p) {

        /**
         * Used as innerHTML for the first page link/span.
         * @attribute firstPageLinkLabel
         * @default '&lt;&lt;&nbsp;first'
         */
        p.setAttributeConfig('firstPageLinkLabel', {
            value : '&lt;&lt;&nbsp;first',
            validator : l.isString
        });

        /**
         * CSS class assigned to the link/span
         * @attribute firstPageLinkClass
         * @default 'yui-pg-first'
         */
        p.setAttributeConfig('firstPageLinkClass', {
            value : 'yui-pg-first',
            validator : l.isString
        });
    };

    // Instance members and methods
    Paginator.ui.FirstPageLink.prototype = {

        /**
         * The currently placed HTMLElement node
         * @property current
         * @type HTMLElement
         * @private
         */
        current   : null,

        /**
         * Link node
         * @property link
         * @type HTMLElement
         * @private
         */
        link      : null,

        /**
         * Span node (inactive link)
         * @property span
         * @type HTMLElement
         * @private
         */
        span      : null,

        /**
         * Generate the nodes and return the appropriate node given the current
         * pagination state.
         * @method render
         * @param id_base {string} used to create unique ids for generated nodes
         * @return {HTMLElement}
         */
        render : function (id_base) {
            var p     = this.paginator,
                c     = p.get('firstPageLinkClass'),
                label = p.get('firstPageLinkLabel');

            this.link     = document.createElement('a');
            this.span     = document.createElement('span');

            this.link.id        = id_base + '-first-link';
            this.link.href      = '#';
            this.link.className = c;
            this.link.innerHTML = label;
            YAHOO.util.Event.on(this.link,'click',this.onClick,this,true);

            this.span.id        = id_base + '-first-span';
            this.span.className = c;
            this.span.innerHTML = label;

            this.current = p.get('recordOffset') < 1 ? this.span : this.link;
            return this.current;
        },

        /**
         * Swap the link and span nodes if appropriate.
         * @method update
         * @param e {CustomEvent} The calling change event
         */
        update : function (e) {
            if (e && e.prevValue === e.newValue) {
                return;
            }

            var par = this.current ? this.current.parentNode : null;
            if (this.paginator.get('recordOffset') < 1) {
                if (par && this.current === this.link) {
                    par.replaceChild(this.span,this.current);
                    this.current = this.span;
                }
            } else {
                if (par && this.current === this.span) {
                    par.replaceChild(this.link,this.current);
                    this.current = this.link;
                }
            }
        },

        /**
         * Removes the link/span node and clears event listeners
         * removal.
         * @method destroy
         * @private
         */
        destroy : function () {
            YAHOO.util.Event.purgeElement(this.link);
            this.current.parentNode.removeChild(this.current);
            this.link = this.span = null;
        },

        /**
         * Listener for the link's onclick event.  Pass new value to setPage method.
         * @method onClick
         * @param e {DOMEvent} The click event
         */
        onClick : function (e) {
            YAHOO.util.Event.stopEvent(e);
            this.paginator.setPage(1);
        }
    };

    })();

Copyright © 2008 Yahoo! Inc. All rights reserved.